import java.io.*;
class QPStateChanger implements Definitions
{

public static void main(String args[]) throws IOException
	{
		
		//ffchanger(64,3,"PFFI0.txt");
		//ffchanger(64,3,"QFFI0.txt");
                //ffchanger(64,9,"FFIC_Q.txt");
                
                polchanger(64,3,"PPOL0.txt");
		polchanger(64,3,"QPOL0.txt");
                polchanger(64,9,"POLC_Q.txt");
		
	}

	static void readQvalues(int statenum, int actionnum, String filename, double old_p_vals[][])
	{
		DataInputStream dis;
                int i,j;
		
		try{
			dis=new DataInputStream(new FileInputStream (filename));
			try{
				for (i=0;i<statenum;i++)
				{
					for(j=0;j<actionnum;j++)
					{
						old_p_vals[i][j]=dis.readDouble();						
					}		
				}
			}catch(Exception e){
				System.out.println("readQvalues: Could not read the q values");
			}
		
			dis.close();
		}catch(Exception e){
			System.out.println("readQvalues: Problem with the file operation" );
		}
		
		
	}	
        
        
	static void ffchanger( int statenum, int actionnum, String filename)
	{
	
                double new_p_vals[][];
                double old_p_vals[][];
		int i,j,k,l;
	
				
	
                        old_p_vals=new double[statenum][actionnum];
                        new_p_vals=new double[statenum][actionnum];
                        
			System.out.println("1");
			readQvalues(statenum, actionnum, filename, old_p_vals);
                      
						
			System.out.println("2");			
				for (i=0;i<4;i++)           //Divide the state scale to four
				{				
					for (j=0;j<4;j++)   //Copy the first four elements of each division to all 16 of the division
					{
                                             for (k=0;k<4;k++)   
                                                        //i*16+j indicates the state we are copying
                                                        //i*16+ j*4 + k indicates the state we are copying to
                                             {           
                                                        for (l=0;l<actionnum;l++)
                                                        {
                                                               new_p_vals[i*16+ j*4 + k][l] = old_p_vals[i*16+j][l];
                                                        }
                                                        System.out.println ("Copied state " + (int)(i*16+j)  + " to state  " + (int)(i*16+ j*4 + k) );
                                             }           
					}
				}
			
		        writePvalues (filename ,new_p_vals, statenum,actionnum);
		
	
	}

        static void polchanger( int statenum, int actionnum, String filename)
	{
	
                double new_p_vals[][];
                double old_p_vals[][];
		int i,j,k,l;
	
				
	
                        old_p_vals=new double[statenum][actionnum];
                        new_p_vals=new double[statenum][actionnum];
                        
			System.out.println("1");
			readQvalues(statenum, actionnum, filename, old_p_vals);
                      
						
			System.out.println("2");			
				for (i=0;i<4;i++)           //Divide the state scale to four
				{				
					for (j=0;j<4;j++)   //Copy the last four elements of each division to all 16 of the division
					{
                                             for (k=0;k<4;k++)   
                                                        //i*16+ (12+j) indicates the state we are copying
                                                        //i*16+ j*4 + k indicates the state we are copying to
                                             {           
                                                        for (l=0;l<actionnum;l++)
                                                        {
                                                               new_p_vals[i*16+ j*4 + k][l] = old_p_vals[i*16+ (12+j)][l];
                                                        }
                                                        System.out.println ("Copied state " + (int)(i*16+ (12+j))  + " to state  " + (int)(i*16+ j*4 + k) );
                                             }           
					}
				}
			
		        writePvalues (filename ,new_p_vals, statenum,actionnum);
		
	
	}

        
	static void writePvalues(String p_filename , double [][] pvals, int statenum, int actionnum)
	{
			DataOutputStream dos;	
			try{
					dos=new DataOutputStream(new FileOutputStream (p_filename,false));
					try{
			
						int i,j;
						for (i=0;i<statenum;i++)
						{
							for(j=0;j<actionnum;j++)
							{
								dos.writeDouble(pvals[i][j]);
							}
						}
					}catch(Exception e){
						System.out.println("writePvalues: Error while writing data");
					}
					dos.close();
				}catch(Exception e){
							System.out.println("writePvalues: Error while opening file" );
				}
	}


}
