// Copyright (C) 2002 Takeshi Morimoto <morimoto@takopen.cs.uec.ac.jp> 
// All rights reserved.
//package sample;

import java.net.*;
import yab.agent.*;
import yab.agent.object.*;

public class CivilianAgent extends AbstractCivilianAgent {
    public CivilianAgent(InetAddress address, int port) {
        super(address, port);
    }

    protected void act() throws ActionCommandException {
        if (self().motionlessPosition() instanceof Refuge)
            rest();
        move(world.refuges);
    }

    protected void hear(RealObject sender, String message) {
        // do nothing
    }
}
