
interface  Definitions
{

static final int DEF_NUM_TICKS=300; 		//number of ticks the simulation continues
static final int DEF_SEND_PORT=6000;
static final int DEF_IO_BUFFER_SIZE=1600;

static final int DEF_REPORTED_ROAD_CLEAR_TIME=15; //After this many cycles the reported roads is cleared
static final int DEF_POSITION_UPDATE_TIME=10;	  //Position update is sent at this much intervals	

static final int INTERMEDIATE_REWARD=2;		//The reward gotten indirectly
static final double ACCUMULATED_REWARD=0.3;	//The reward gotten from jobs that are ruined and taken out of the queue
static final double QUEUE_REWARD=0.3;           //The 
static final double def_reward_step=0.3;		//How much the reward function increases or decreases

static final short DEF_NUM_MY_LEVELS=16;
static final short DEF_NUM_OTHER_LEVELS=2;

static final int def_controller_action_num=9;    //ACTION 0: assign most urgent job first(iterating jobs), ACTION 1: assign closest job first(iterating agents) 
static final int def_agent_action_num=3;		 //Actions available to agents
static final int def_action_source_num=3;		 //Environment, dispatcher, own

static final byte ACTION_SOURCE_OWN=0;           //00
static final byte ACTION_SOURCE_CENTER=1;        //01
static final byte ACTION_SOURCE_ENVIRONMENT=2;   //10
static final byte ACTION_SOURCE_CENTER_ENV=3;    //11
static final byte ACTION_SOURCE_CENTER_OWN=4;    //11

static final byte PUT_BACK=0;
static final byte TAKE_OUT=1;

static final byte ALT_NO_ALT=-1;                //Preemption alternatives. Mean no-alternative or there is alternative
static final byte ALT_CENTER_ENV=1;

static final byte MAX_PREEMPT_PRIORITY=2;

static final byte SAVED_BY_ME= 0;
static final byte SAVED_BY_OTHER=2;
static final byte NOT_SAVED_YET=4;
static final byte JOB_STATUS_UNKNOWN=8;
static final byte RUINED=16;
static final byte NOT_RUINED=32;

static final byte URGENT_BASE = 0;
static final byte CONTROLLER_URGENT_FIRST = 0;
static final byte CONTROLLER_URGENT_2_BY_2 = 1;
static final byte CONTROLLER_URGENT_3_BY_3 = 2;


static final byte CLOSEST_BASE = 3;
static final byte CONTROLLER_CLOSEST_FIRST =3;
static final byte CONTROLLER_CLOSEST_2_BY_2 = 4;
static final byte CONTROLLER_CLOSEST_3_BY_3 = 5;

static final byte LIGHTEST_BASE = 6;
static final byte CONTROLLER_LIGHTEST_1_BY_1 = 6;
static final byte CONTROLLER_LIGHTEST_2_BY_2 = 7;
static final byte CONTROLLER_LIGHTEST_3_BY_3 = 8;

static final byte WORKER_URGENT_FIRST = 0;
static final byte WORKER_CLOSEST_FIRST = 1;
static final byte WORKER_LIGHTEST_FIRST = 2;


static final double def_learning_rate=0.5;		//How much the rewards etc. affect the q-values
static final boolean def_p_explorer=false;  		//false if the agent has learned enough, and should do greedy actions.
static final boolean def_q_explorer=false;
static final boolean def_center_explorer=false;

static final byte def_environment_types=3;	//Civilian, building, road 
static final byte def_agent_num=4;			//Firefighter,police,ambulance,controller
static final byte def_other_num=2;			//All the rest are grouped together

static final byte WORLD_MODEL_BUILDING_INDEX=0;
static final byte WORLD_MODEL_ROAD_INDEX=1;
static final byte WORLD_MODEL_CIVILIAN_INDEX=2;
static final byte WORLD_MODEL_FIREFIGHTER_INDEX=3;
static final byte WORLD_MODEL_POLICE_INDEX=4;
static final byte WORLD_MODEL_AMBULANCE_INDEX=5;
static final byte WORLD_MODEL_CONTROLLER_INDEX=6;
static final byte WORLD_MODEL_OTHER_INDEX=7;
static final byte WORLD_MODEL_REFUGE_INDEX=8;

static final int MY_MAXINT = Integer.MAX_VALUE;//0x7FFFFFFF;
static final short MY_MAXSHORT = Short.MAX_VALUE;//0x7FFFFFFF;
static final double MY_MAXDOUBLE = Double.MAX_VALUE;
static final double MY_MINDOUBLE = -Double.MAX_VALUE;
static final double MAX_DISTANCE=Double.MAX_VALUE;


static final int MAX_SEVERE_BUILDING=3;         //Found in Route 2/3 
static final int MAX_SEVERE_ROAD=0x7FFFFFFF;
static final int MAX_SEVERE_CIVILIAN=0;

static final int MIN_SEVERE_BUILDING=0;
static final int MIN_SEVERE_ROAD=0;
static final int MIN_SEVERE_CIVILIAN=10000;     //Kernel sends it this way
static final int HELP_REQUESTING_CIVILIAN=5000;

static final int EXTINGUISHED_BUILDING1=4;
static final int EXTINGUISHED_BUILDING2=5;
static final int EXTINGUISHED_BUILDING3=6;
static final int BURNED_OUT_BUILDING=7;

static final short MAX_TANK_CAPACITY=15000;

static final double ABS_MAX_SEVERE_BUILDING=1;
static final double ABS_MAX_SEVERE_ROAD=1;
static final double ABS_MAX_SEVERE_CIVILIAN=0;

static final double ABS_MIN_SEVERE_BUILDING=0;
static final double ABS_MIN_SEVERE_ROAD=0;
static final double ABS_MIN_SEVERE_CIVILIAN=1;

static final byte MAX_MSG_SEND=4;
static final byte MAX_MSG_RCV=4;

static final double def_burnt_importance_rate=0.6;
static final double def_burning_importance_rate=0.4;
static final double def_death_importance_rate=0.6;
static final double def_injury_importance_rate=0.4;				

static final double def_q_accept_probability = 2.0 / 3.0;				//If exploring, with what probability worse actions are preferred
static final double def_p_accept_probability = 2.0/3.0; 
static final double def_center_accept_probability = 8.0/9.0;
static final int def_discount_interval=5;
static final double def_discount_rate=0.01;

static final int HEADER_NULL=0x00;

static final int KA_SENSE =0x52;		//Coming from kernel
static final int KA_HEAR =0x53;
static final int KA_CONNECT_OK =0x50;

static final int AK_SAY =0x84;			//Going to kernel
static final int AK_TELL =0x85;
static final int AK_MOVE =0x81;
static final int AK_CONNECT =0x10;
static final int AK_ACKNOWLEDGE =0x11;
static final int AK_EXTINGUISH =0x86;
static final int AK_RESCUE =0x88;
static final int AK_LOAD =0x82;
static final int AK_UNLOAD =0x83;
static final int AK_CLEAR =0x89;
static final int AK_REST =0x80;


static final int JOB_REWARD=16;
static final int AMBULANCE_REWARD=16;
static final int POLICE_REWARD=16;
static final int FIREFIGHTER_REWARD=16;
static final double POLICE_DELAY_DISCOUNT_RATE=0.1;

//WE DO NOT NEED TO SEND IT DOES NOT CHANGE ANYTHINGstatic final int MSG_NEUTRAL =0;		//Detailed message types for AK_SAY
static final int MSG_SUCCESS =10;		//Detailed message types for AK_SAY
static final int MSG_FAILURE =12;		//Detailed message types for AK_SAY
static final int MSG_NEUTRAL_POS=14;
static final int MSG_NEUTRAL_NEG=16;
static final int MSG_REQUEST =18;		//Detailed message types for AK_SAY
static final int MSG_EXECUTE =20;		//Detailed message types for AK_SAY
static final int MSG_ROAD_CLEARED =22;
static final int MSG_FIERY_BUILDING=24;

static final int MSG_EXPOS =30;
static final int MSG_EXPOS_AMB1 =30;
static final int MSG_EXPOS_AMB2 =31;
static final int MSG_EXPOS_AMB3 =32;
static final int MSG_EXPOS_AMB4 =33;
static final int MSG_EXPOS_AMB5 =34;
static final int MSG_EXPOS_AMB6 =35;
static final int MSG_EXPOS_AMB7 =36;
static final int MSG_EXPOS_AMB8 =37;

static final int MSG_CLEAR=40;
static final int MSG_HELPCIVID=41;
static final int MSG_HELPCIVPOS=42;
static final int MSG_POSITION=43;
static final int MSG_HELPCIVPENDINGPOS=44;

static final int MSG_EXECUTE_LIMIT=49;
static final int MSG_FIREFIGHTER_EXECUTE=50;
static final int MSG_POLICE_EXECUTE=70;
static final int MSG_AMBULANCE_EXECUTE=90;


//FOLLOWING INDEXES ARE ON BYTE ARRAY
static final int MSG_HEADER_ID_INDEX=2;
static final int MSG_HEADER_COUNT_INDEX=4;
static final int MSG_HEADER_TOTAL_INDEX=6;

static final int MSG_FORMAT_TYPE_INDEX=8;
static final int MSG_FORMAT_SIZE_INDEX=12;
static final int MSG_FORMAT_BODY_INDEX=16;

static final int MSG_FORMAT_HEAR_TYPE_INDEX=128;//0;//24; 20020407
static final int MSG_FORMAT_HEAR_SUBJECT_INDEX=2;//26;


//FOLLOWING INDEXES ARE ON INT ARRAY 	WHICH DO NOT CONTAIN THE 8 BYTE HEADER
static final int MSG_FORMAT_LONG_TYPE_INDEX=0;	//Long packets are combined without header, so the index changes from 8 to 0
static final int MSG_FORMAT_LONG_SIZE_INDEX=1;  
static final int MSG_FORMAT_LONG_BODY_INDEX=2;  

static final int MSG_HEAR_USEFUL_SIZE=3;	//all ak_say messages have 12 bytes of useful info:msg_type(2)+subject_id(10)
static final int MSG_FORMAT_HEAR_SENDER_ID=3;
static final int MSG_FORMAT_HEAR_SIZE=4;
static final int MSG_FORMAT_HEAR_MSG_DETAILS=5;
static final int MSG_FORMAT_HEAR_MSG_SUBJECT=10;


//static final int MSG_FORMAT_HEAR_DETAIL=5;

static final int MSG_FORMAT_SENSE_ID=2;			//Same index for connect
static final int MSG_FORMAT_SENSE_TIME=3;		
static final int MSG_FORMAT_CONNECT_ID_INDEX=3;//0 is type, 1 is size,2 is temp id,
static final int MSG_FORMAT_SENSE_OBJECT=4;		//Same index for connect


/*TYPES SENT WITH KA_SENSE*/

static final int TYPE_NULL             = 0;
static final int TYPE_ROAD             = 168;
static final int TYPE_RIVER            = 169;
static final int TYPE_BUILDING         = 176;
static final int TYPE_REFUGE           = 184;
static final int TYPE_FIRE_STATION     = 185;
static final int TYPE_AMBULANCE_CENTER = 186;
static final int TYPE_POLICE_OFFICE    = 187;
static final int TYPE_RIVER_NODE       = 201;
static final int TYPE_NODE             = 200;
static final int TYPE_WORLD            = 208;
static final int TYPE_CIVILIAN         = 232;
static final int TYPE_FIRE_BRIGADE     = 233;
static final int TYPE_AMBULANCE_TEAM   = 234;
static final int TYPE_POLICE_FORCE     = 235;
static final int TYPE_CAR              = 236;

/*TYPES SENT WITH AK_CONNECT*/

static final int CONNECT_CIVILIAN		  = 1;
static final int CONNECT_FIRE_BRIGADE     = 2;
static final int CONNECT_FIRE_STATION     = 4;
static final int CONNECT_AMBULANCE_TEAM   = 8;
static final int CONNECT_AMBULANCE_CENTER = 16;
static final int CONNECT_POLICE_FORCE     = 32;
static final int CONNECT_POLICE_OFFICE    = 64;

static final int ID_NULL				= 0;

  static final int PROPERTY_NULL                  = 0;
  static final int PROPERTY_X                     = 3;
  static final int PROPERTY_Y                     = 4;
  static final int PROPERTY_POSITION              = 6;
  static final int PROPERTY_POSITION_EXTRA        = 7;
  static final int PROPERTY_STAMINA               = 9;
  static final int PROPERTY_HP                    = 10;
  static final int PROPERTY_DAMAGE                = 11;
  static final int PROPERTY_HEAD                  = 12;
  static final int PROPERTY_TAIL                  = 13;
  static final int PROPERTY_FLOORS                = 14;
  static final int PROPERTY_BUILDING_ATTRIBUTES   = 15;
  static final int PROPERTY_FIERYNESS             = 16;
  static final int PROPERTY_BROKENNESS            = 17;
  static final int PROPERTY_ROAD_KIND             = 19;
  static final int PROPERTY_BLOCK                 = 22;
  static final int PROPERTY_BURIEDNESS            = 23;
  static final int PROPERTY_LENGTH                = 24;
  static final int PROPERTY_WATER_QUANTITY        = 25;
  static final int PROPERTY_STRETCHED_LENGTH      = 26;
  static final int PROPERTY_DIRECTION             = 27;
  static final int PROPERTY_START_TIME            = 29;
  static final int PROPERTY_LONGITUDE             = 30;
  static final int PROPERTY_LATITUDE              = 31;
  static final int PROPERTY_WIND_FORCE            = 32;
  static final int PROPERTY_WIND_DIRECTION        = 33;
  static final int PROPERTY_CARS_PASS_TO_HEAD     = 34;
  static final int PROPERTY_CARS_PASS_TO_TAIL     = 35;
  static final int PROPERTY_HUMANS_PASS_TO_HEAD   = 36;
  static final int PROPERTY_HUMANS_PASS_TO_TAIL   = 37;
  static final int PROPERTY_WIDTH                 = 38;
  static final int PROPERTY_REPAIR_COST           = 39;
  static final int PROPERTY_MEDIAN_STRIP          = 40;
  static final int PROPERTY_LINES_TO_HEAD         = 41;
  static final int PROPERTY_LINES_TO_TAIL         = 42;
  static final int PROPERTY_WIDTH_FOR_WALKERS     = 43;
  static final int PROPERTY_SIGNAL                = 44;
  static final int PROPERTY_IGNITION              = 48;
  static final int PROPERTY_BUILDING_CODE         = 50;
  static final int PROPERTY_BUILDING_AREA_GROUND  = 51;
  static final int PROPERTY_BUILDING_AREA_TOTAL   = 52;
  static final int PROPERTY_SHORTCUT_TO_TURN      = 128;
  static final int PROPERTY_POCKET_TO_TURN_ACROSS = 129;
  static final int PROPERTY_SIGNAL_TIMING         = 130;
  static final int PROPERTY_BUILDING_APEXES       = 131;
  static final int PROPERTY_POSITION_HISTORY      = 207;
  static final int PROPERTY_ENTRANCES             = 235;
  static final int PROPERTY_EDGES                 = 242;


  static final int TYPE_FIRE_COMPANY = TYPE_FIRE_BRIGADE;

  static final int ROUTER_PREPARE_MAX_LEVELS	  = 2000;
  static final int ROUTER_SEND_MAX_LEVELS		  = 398;
  static final int FIREFIGHTER_EXTINGUISHABLE_DISTANCE = 30000;
  static final int FIREFIGHTER_EXTINGUISHABLE_QUANTITY = 1000;
  static final int AMBULANCE_TARGET_STATUS_NOT_FOUND = 0;
  static final int AMBULANCE_TARGET_STATUS_RESCUING = 100;
  static final int AMBULANCE_TARGET_STATUS_LOADED = 200;
  static final int AMBULANCE_TARGET_STATUS_UNLOADED = 300;


  static final byte NULL_ROUTE=-1;
  static final byte NULL_ROUTE1=-8;
  static final byte NULL_ROUTE2=-16;										//Used by findroutebetween
  static final byte CLEAR_ROUTE=-2;
  static final byte DROP_JOB=-3;

  static final byte NOT_ARRIVED_TO_TARGET	         = -2;		//used by police officers
  static final byte ARRIVED_TO_TARGET			 = 0;
  static final byte MOVE_TO_INTERMEDIATE_TARGET           = 2;
  static final byte CLEAR_INTERMEDIATE_TARGET             = 4;


  static final byte msgtype_len=2;
  static final byte subj_len=10;
  static final byte agent_len=12;
  //static final int secsubj_len=15;
  //Sum of above 3 fields must be a multiple of 4 -->now 12

  static final boolean IS_qLOGGING=false; //true means that q values are logged to LOG file, Q-values are always written to Q-value files
  static final boolean IS_LOGGING=false;
  static final boolean C_LOGGING=false;
  static final boolean W_LOGGING=false;
  static final boolean R_LOGGING=false;
  static final boolean AMB_LOGGING=false;
  static final boolean POL_LOGGING=false;
  static final boolean FF_LOGGING=false;
  static final boolean GEN_LOGGING=false;
  static final boolean PRE_LOGGING=false;
  static final boolean COMM_LOGGING=false;
  static final boolean X_LOGGING=false;

  static final boolean NEAR_AGENT_RESCUABLE=true;

  static final byte STEPS_AGENT_FREEZED=3;
  static final byte STEPS_BLOCK_ARRIVE=3;
  static final byte PREEMPTION_RATE=1;

  static final int def_environment_levels=4;	//good, bad etc...Used by QValInline and QValViewer

  //DEPRECATED:
	//static final int DEF_UPDATE_WRITE_RATE=50;	//How often the q values are written to file
	//static final int DEF_OLD_JOB=20;			//At time 300 this old jobs at hand are considered failure
	//static final int DEF_AMBULANCE_TIME_OUT=50;
	//static final int DEF_FIREFIGHTER_TIME_OUT=50;
	//static final int DEF_POLICE_TIME_OUT=30;
	//static final int def_priority_type_num=10;
	//static final int MAX_STUCK_ALLOWED=5;   
	//static final byte WORLD_MODEL_STATIC_TYPE=0; 	//Type of id passed in static object or moving object, used in closest/farthest functions
	//static final byte WORLD_MODEL_MOVING_TYPE=1;
	//static final byte WORLD_MODEL_ROUTENODE_TYPE=2;
	//static final int def_maximum_severity=10;
        //static final int AGENT_STATUS_NO_JOB = 0;								//Used by agentthd
        //static final int AGENT_STATUS_ASKED_KERNEL = 100;
        //static final int AGENT_STATUS_HAVE_JOB = 200;
        //static final byte TARGET_TYPE_NONE=0;
        //static final byte TARGET_TYPE_OWN=10;
        //static final byte TARGET_TYPE_CENTER=20;
        //static final byte TARGET_TYPE_OTHERS=30;

}
