import java.net.*;

class RoboAkut implements Definitions
{
	public static void main(String args[]) 
	{
		int num_ambulance;
		int num_police;
		int num_firefighter;
		//int num_civilian;
		int i;		
		String inetaddr="localhost";
		int training_run_num=0;
				
		num_firefighter=Integer.parseInt(args[0]);
		num_ambulance=Integer.parseInt(args[2]);
		num_police=Integer.parseInt(args[4]);
		//num_civilian=Integer.parseInt(args[3]);
		
		AmbulanceTeam [] ambulanceArr;
		FireFighterTeam  [] firefighterArr;
		PoliceTeam  [] policeArr;
		//CivilianThd [] civArr;
		
		if (args.length>=7)
		{
			inetaddr=args[6];
		}
		
		if (args.length==8)
		{
			training_run_num=Integer.parseInt(args[7]);
		}
		
		if (Integer.parseInt(args[1])>0)
		{
			FireFighterController ffController;
		
			ffController=new FireFighterController(CONNECT_FIRE_STATION,inetaddr,training_run_num);
			ffController.start();
		}
	
		if (Integer.parseInt(args[3])>0)
		{
			AmbulanceController aController;
		
			aController=new AmbulanceController(CONNECT_AMBULANCE_CENTER,inetaddr,training_run_num);
			aController.start();
		}
	
		if (Integer.parseInt(args[5])>0)
		{
			PoliceController pController;
		
			pController=new PoliceController(CONNECT_POLICE_OFFICE,inetaddr,training_run_num);
			pController.start();
		}
	
		if (num_firefighter>0)
		{
			firefighterArr=new FireFighterTeam[num_firefighter];
		
			for (i=0;i<firefighterArr.length;i++)
			{
				firefighterArr[i]=new FireFighterTeam(CONNECT_FIRE_BRIGADE, "FFI"+i,inetaddr,training_run_num);
				firefighterArr[i].start();
			}
		}
		
		if (num_police>0)
		{
			policeArr=new PoliceTeam[num_police];
			for (i=0;i<policeArr.length;i++)
			{
				policeArr[i]=new PoliceTeam(CONNECT_POLICE_FORCE, "POL"+i,inetaddr,training_run_num);
				policeArr[i].start();
			}
		}
		
		if (num_ambulance>0)
		{
			ambulanceArr=new AmbulanceTeam[num_ambulance];

			for (i=0;i<ambulanceArr.length;i++)
			{
				ambulanceArr[i]=new AmbulanceTeam(CONNECT_AMBULANCE_TEAM, "AMB"+i,inetaddr,training_run_num);
				ambulanceArr[i].start();
			}
		}
		
		/*
		if (num_civilian>0)
		{
			civArr=new CivilianThd[num_civilian];

			for (i=0;i<civArr.length;i++)
			{
				civArr[i]=new CivilianThd(CONNECT_CIVILIAN, "CIV"+i);
				civArr[i].start();
			}
		}
		*/
	}
}
